#include "PlotCtf.h"
#include "qprinter.h"

#define Inherited PlotCtfData

extern int initdone;

char *labfn(float val,int isy) {
static char r[30];

sprintf(r,"1/%1.2f",1.0/val);
return r;
}

PlotCtf::PlotCtf(QWidget* parent,const char* name):Inherited( parent, name )
{
//initMetaObject();
data=NULL;
axes->setBackgroundMode( QWidget::NoBackground );
axes->setAction(LeftButton|ControlButton,D2_ACT_LEGEND);
axes->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0
	,D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS|D2_OPT_LABEL,
	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_LABEL);
axes->setlabfn(labfn);

axes2=NULL;
mode2=-1;

colors.append(new QColor(0x20,0x20,0x20));
colors.append(new QColor(0x0,0x0,0x0));
colors.append(new QColor(0,0,0xc0));
colors.append(new QColor(0xc0,0,0));
colors.append(new QColor(0,0xc0,0));
colors.append(new QColor(0xc0,0,0xc0));
colors.append(new QColor(0,0xc0,0xc0));

colors2.append(new QColor(0x20,0x20,0x20));
colors2.append(new QColor(0x60,0x60,0x60));
colors2.append(new QColor(0x20,0x20,0xa0));
colors2.append(new QColor(0xa0,0x20,0x20));
colors2.append(new QColor(0x20,0xa0,0x20));
colors2.append(new QColor(0xa0,0x20,0xa0));
colors2.append(new QColor(0x20,0xa0,0xa0));

QObject::connect(discomp,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(disctf,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(disstig,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(dissnr,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(disptcl,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(disstruc,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(disusr,SIGNAL(clicked()),this,SLOT(newmode()));
QObject::connect(disusrc,SIGNAL(clicked()),this,SLOT(newmode()));

QObject::connect(dis2none,SIGNAL(clicked()),this,SLOT(newmode2()));
QObject::connect(dis2comp,SIGNAL(clicked()),this,SLOT(newmode2()));
QObject::connect(dis2struc,SIGNAL(clicked()),this,SLOT(newmode2()));


mode=0;
}


PlotCtf::~PlotCtf()
{
}

void PlotCtf::resizeEvent ( QResizeEvent *ev) {
//if (!initdone) return;
//axes->resize(axes->width()+ev->size().width()-ev->oldSize().width(),
//	axes->height()+ev->size().height()-ev->oldSize().height());
axes->resize(ev->size().width()-110,ev->size().height()-10);
} 

void PlotCtf::newplots() {
CtfData *d;
DataSet *ds;
LSPlot *p;

axes->noPlots();
colors.first();
colors2.first();

if (!data) return;

for (int itn=0; (d=(CtfData *)data->item(itn)); itn++) {

	if ((d->flags()&CDT_PLOT) ) {
		p=d->getPlot(1);
		p->setFlags(LS_LINE);
		p=d->getPlot(0);
		if (colors.next()) colors.prev(); else { colors.first(); colors2.first(); }
		
		p->setColor(colors.next());
//		d->setColor(*colors.current());
		switch(mode) {
		case 0:
			p->setCols(0,6,0,0);
			axes->addPlot(p);
			axes->setYLabel("Intensity");

			if (!(d->flags()&CDT_HASFFT)) {
				colors2.next();
				break;
			}
			p=d->getPlot(1);
//			p->setFlags(LS_SYM);
//			p->setSym(SYM_CIRCLE,5);
			p->setColor(colors2.next());
			p->setCols(0,10,0,0);
			axes->addPlot(p);
			break;
		case 1:
			p->setCols(0,3,0,0);
			axes->addPlot(p);
			axes->setYLabel("CTF Amplitude");
			break;
		case 2:
			p->setCols(0,6,0,0);
			axes->addPlot(p);
			axes->setYLabel("Intensity");

			p=d->getPlot(1);
			p->setColor(colors.next());
			p->setCols(0,7,0,0);
			axes->addPlot(p);

			if (!(d->flags()&CDT_HASFFT)) {
				break;
			}

			p=d->getPlot(2);
			p->setColor(colors2.next());
			p->setCols(0,10,0,0);
			axes->addPlot(p);


			p=d->getPlot(3);
			p->setColor(colors2.next());
			p->setCols(0,12,0,0);
			axes->addPlot(p);

			break;
		case 3:
			p->setCols(0,8,0,0);
			axes->addPlot(p);
			axes->setYLabel("Signal/Noise");
			break;
		case 4:
			p->setCols(0,9,0,0);
			axes->addPlot(p);
			axes->setYLabel("# Ptcl. Reqd.");
			break;
		case 5:
			p->setCols(0,11,0,0);
			axes->addPlot(p);
			axes->setYLabel("Structure Factor");

			p=d->getPlot(1);
			p->setColor(colors2.next());
			p->setCols(0,13,0,0);
			axes->addPlot(p);
			break;
		case 6:
			p->setCols(0,14,0,0);
			axes->addPlot(p);
			axes->setYLabel("Intensity");

			colors2.next();
			break;
		case 7:
			p->setCols(0,14,0,0);
			axes->addPlot(p);
			axes->setYLabel("Intensity");

			if (!(d->flags()&CDT_HASFFT)) {
				colors2.next();
				break;
			}
			p=d->getPlot(1);
//			p->setFlags(LS_SYM);
//			p->setSym(SYM_CIRCLE,5);
			p->setColor(colors2.next());
			p->setCols(0,10,0,0);
			axes->addPlot(p);
			break;
		}
		axes->setXLabel("S (1/A)");
	
	}

}
//if (mode>=4) axes->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS|D2_OPT_LABEL,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_LOG|D2_OPT_LABEL);
//else axes->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS|D2_OPT_LABEL,D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_LABEL);

newplots2();
}

void PlotCtf::newplots2() {
CtfData *d;
DataSet *ds;
LSPlot *p;

if (mode2==-1) {
	if (axes2) delete axes2;
	axes2=NULL;
	return;
}

if (!axes2) {
	axes2=new Axes2d;
	axes2->resize(400,300);
	axes2->setAction(LeftButton|ControlButton,D2_ACT_LEGEND);
	axes2->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0,
		D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS|D2_OPT_LABEL,
		D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_LABEL);
	axes2->setlabfn(labfn);
}

axes2->noPlots();
colors.first();
colors2.first();

if (!data) return;

for (int itn=0; (d=(CtfData *)data->item(itn)); itn++) {

	if ((d->flags()&CDT_PLOT) ) {
		p=d->getPlot(5);
		p->setFlags(LS_LINE);
		p=d->getPlot(4);

		if (colors.next()) colors.prev(); else { colors.first(); colors2.first(); }
		
		p->setColor(colors.next());
		switch(mode2) {
		case 0:
			p->setCols(0,6,0,0);
			axes2->addPlot(p);
			axes2->setYLabel("Intensity");

			if (!(d->flags()&CDT_HASFFT)) {
				colors2.next();
				break;
			}
			p=d->getPlot(5);
			p->setColor(colors2.next());
			p->setCols(0,10,0,0);
			axes2->addPlot(p);
			break;
		case 5:
			p->setCols(0,11,0,0);
			axes2->addPlot(p);
			axes2->setYLabel("Structure Factor");
			break;
		}
		axes2->setXLabel("S (1/A)");
	
	}

}
//if (mode2>=4) axes2->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS|D2_OPT_LABEL,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_LOG|D2_OPT_LABEL);
//else axes2->setOptions(D2_OPT_AUTOSCALE|D2_OPT_FRAME|D2_OPT_SHOWY0,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_CSCA|D2_OPT_AXIS|D2_OPT_LABEL,
//	D2_OPT_SCALE|D2_OPT_TIC|D2_OPT_LABEL);

axes2->show();

}

void PlotCtf::replot() {
axes->update();
if (axes2) axes2->update();
}

void PlotCtf::print() {
QPrinter qp;

qp.setPageSize(QPrinter::Letter);
if (qp.setup()) axes->print(&qp);

}

void PlotCtf::newmode2() {

if (dis2none->isOn()) mode2=-1;
else if (dis2comp->isOn()) mode2=0;
else if (dis2struc->isOn()) mode2=5;

newplots2();

if (axes2) {
	if (mode2>4) axes2->setOptions(axes2->getOptions(),axes2->getXOpt(),axes2->getYOpt()|D2_OPT_LOG);
	else axes2->setOptions(axes2->getOptions(),axes2->getXOpt(),axes2->getYOpt()&(~D2_OPT_LOG));
}
}

void PlotCtf::newmode() {

if (discomp->isOn()) mode=0;
else if (disctf->isOn()) mode=1;
else if (disstig->isOn()) mode=2;
else if (dissnr->isOn()) mode=3;
else if (disptcl->isOn()) mode=4;
else if (disstruc->isOn()) mode=5;
else if (disusr->isOn()) mode=6;
else if (disusrc->isOn()) mode=7;

if (mode>4) axes->setOptions(axes->getOptions(),axes->getXOpt(),axes->getYOpt()|D2_OPT_LOG);
else axes->setOptions(axes->getOptions(),axes->getXOpt(),axes->getYOpt()&(~D2_OPT_LOG));

//printf("newmode(%d)\n",mode);

newplots();
}
